
set_parameters
Gq=262144*10^-6;
u=60/3.6;
%% pid
Kp=2249.54424;
Ki=2722.04638;
Kd=0.30244;
lambda0=1;
mu0=1;
%%
gain_noise=2*pi*n0*sqrt(Gq*u);
T=(l1+l2)/u;
mdlWks = get_param('model_8','ModelWorkspace');
assignin(mdlWks,'Kp',Kp);
assignin(mdlWks,'Ki',Ki);
assignin(mdlWks,'Kd',Kd);
assignin(mdlWks,'lambda0',lambda0);
assignin(mdlWks,'mu0',mu0);
out=sim("model_8");
z=out.z;
ddz=out.ddz;
zr=out.zr;
zc=z(:,1);
zb=z(:,2);
theta=z(:,3);
phi=z(:,4);
zu=z(:,5:8);   %四个轮的时间变化
zs(:,1)=zb-l1*theta+l3*phi;
zs(:,2)=zb-l1*theta-l4*phi;
zs(:,3)=zb+l2*theta+l3*phi;
zs(:,4)=zb+l2*theta-l4*phi;
zxy=zb-rx*theta+ry*phi;
t=out.tout;                         %时间
data=[ddz(:,1:4),(zs-zu),(zu-zr)];  %12个指标的时间变化，按顺序为 zc zb theta phi的加速度，zs-zu(1-4),zu-zr(1-4)
control=out.control; %控制信号时间变化
RMSE_control=sqrt(mean(control.^2,1)); %控制信号均方根
mean_control=mean(control,1);       %控制信号平均值
RMSE_index=sqrt(mean(data.^2,1)); %12个指标均方根
mean_index=mean(data,1); %12个指标平均值

%% 各种功率谱密度
% 路面对四个轮 zr1-zr4
for i=1:4
    [freq,P_ur(:,i)]=cal_power(1000,zr(:,i));
end
%12个指标的
for i=1:12
    [freq,P_index(:,i)]=cal_power(1000,data(:,i));
end
% plot(freq,P_index(:,1))
